<?php

namespace Teknisa\MAN\Controllers;

use Zeedhi\Framework\Controller\CrudWithParameterBag;
use Zeedhi\Framework\DataSource;
use Zeedhi\Framework\DTO\Response;
use Zeedhi\Framework\DTO\Request;
use Teknisa\MAN\Services\ParaGeraisImportarImpostoService;

class ParaGeraisImportarImposto extends CrudWithParameterBag {

    protected $parameterBagColumns = array('CDFILIAL','NRORG',);
    protected $exportPriceChartService;
    protected $dataSourceName = 'importAliquota';

    public function __construct (DataSource\Manager $dataSourceManager, DataSource\ParameterBag $parameterBag, ParaGeraisImportarImpostoService $impImposto) {
        parent::__construct($dataSourceManager, $parameterBag);
        $this->ParaGeraisImportarImpostoService = $impImposto;
    }
    
    
    public function importIBPT(Request\Row $request, Response $response){
    // realiza rotina de Exportação da Tabela de Preço
        $returnData = Array(
            'STATUS' => ''
        );
        $dataExport = $request->getRow();
        try {
            $returnData['STATUS'] = $this->ParaGeraisImportarImpostoService->importImposto($dataExport);
            self::responseFrontEnd($response, true, $returnData);
        } catch (Exception $e) {
            self::responseFrontEnd($response, false, $e);
        }
    }

    public function responseFrontEnd(&$response, $type, $data){
        if ($type){
            $response->addDataSet(new DataSource\DataSet($this->dataSourceName, $data));
        }
        else
            $response->setError(new Response\Error($data->getMessage(), $data->getCode()));
    }
    
}