<?php
namespace Teknisa\MAN\Controllers;

use Zeedhi\Framework\DataSource;
use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\DataSource\Manager;
use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Response;
use Zeedhi\Framework\DTO\Request;
use Teknisa\MAN\Services;
use Teknisa\MAN\Utilities;

class RelMTCMovProd  {

    protected $RelMTCMovProd;
    protected $utilService;
    
    public function __construct(Services\RelMTCMovProd $RelMTCMovProd, Utilities\Util $utilService) {
        $this->RelMTCMovProd = $RelMTCMovProd;
        $this->utilService = $utilService;
    }
    
    public function find(DTO\Request\Filter $request, DTO\Response $response) {
        
        ini_set('max_execution_time', 1800);
		ini_set('memory_limit', '512M');
		
        $conditions = $this->utilService->getParamsAsArray($request);
        if (isset($conditions['DTHRPEDIDO'])){
            $DTINI = $conditions['DTHRPEDIDO'][0];
            $DTFIN = $conditions['DTHRPEDIDO'][1];
            unset($conditions['DTHRPEDIDO']);
        }
        
        if (isset($conditions['INTERVALISTA']) && $conditions['INTERVALISTA'] == 'I'){
           if (empty($conditions['CDARVPRODF'])){
                $conditions['CDARVPRODF'] = $conditions['CDARVPRODI'];
           }
           $conditions['TCDPRODUTO'] = null;
           $conditions['CDPRODLIST'] = null;
           $conditions['PRODNIV'] = null;
        }elseif (isset($conditions['INTERVALISTA']) && $conditions['INTERVALISTA'] == 'D') {
           $conditions['PRODNIV'] = str_replace('%', '', str_replace('.', '', $conditions['PRODNIV'])).'%';
           $conditions['TCDPRODUTO'] = null;
           $conditions['CDPRODLIST'] = null;
           $conditions['CDARVPRODF'] = null;
           $conditions['CDARVPRODI'] = null;
        }
        elseif (isset($conditions['INTERVALISTA']) && $conditions['INTERVALISTA'] == 'L'){
           $conditions['CDPRODLIST'] = implode('_', $conditions['CDPRODUTO']);
           $conditions['TCDPRODUTO'] = null;
           $conditions['CDARVPRODF'] = null;
           $conditions['CDARVPRODI'] = null;
           $conditions['PRODNIV'] = null;
        }
        else{
           $conditions['TCDPRODUTO'] = 'T';
           $conditions['CDPRODLIST'] = null;
           $conditions['CDARVPRODF'] = null;
           $conditions['CDARVPRODI'] = null;
           $conditions['PRODNIV'] = null;
        }
        $MTCUNIT = $this->RelMTCMovProd->findMTCUNIT($conditions['NRORG'], $conditions['CDFILIAL'], $DTINI, $DTFIN)[0]['MTC'];
        $result = $this->RelMTCMovProd->find($conditions, $DTINI, $DTFIN, $MTCUNIT);
        $response->addDataSet(new DataSet("orm00013_RelMTCMovProd", $result));
    }
    
}